#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_code_real (double val, unsigned *address)
{
	int Ret = HPS_OK;

	if (address)
	{
		int size = 0;
		unsigned addr;
		
		if (isinf (val))
		{
			*address = MAXREAL;
		}
		else if ((Ret = hps_objsize_type (DOREAL, (void *) &val, &size)) == HPS_OK)
		{		
			if (addr = (*address ? *address : (*address = sat_createtemp (size))))
			{
				// Fills the prologue
				sat_poke (addr, DOREAL, 5);

				// Fills the value
				double2real (val, addr + 5);
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
	
	return (Ret);
}
