#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_code_symb (entry_t *val, unsigned *address)
{
	int Ret = HPS_OK;

	if (val && address)
	{
		int size = 0;

		if ((Ret = hps_objsize_type (DOSYMB, (void *) &val, &size)) == HPS_OK)
		{
			unsigned addr;

			if (addr = (*address ? *address : (*address = sat_createtemp (size))))
			{
				int level = 1;
				int size = 0;
				element_t element;
				
				// Fills the prologue
				sat_poke (addr, DOSYMB, 5);
				addr += 5;
				
				while (prs_alg_get_element (val, level, &element) == PRS_OK)
				{
					switch (element.Type)
					{
						case C_TypeVal :
						{
							if (isinf (element.data.Val))
							{
								sat_poke (addr, DOROMP, 5);
								sat_poke (addr+5, xINFINITE, 6);
								size = 11;
							}
							else
							{
								Ret = hps_code_real (element.data.Val, &addr);
								size = 21;
							}
							break;
						}
						
						case C_TypeIdent :
						{
							Ret = hps_code_ident (element.data.Ident, &addr);
							size = strlen (element.data.Ident)*2 + 7;
							break;
						}

						case C_TypeFunc :
						{
							sat_poke (addr, element.data.Func, 5);
							size = 5;
							break;
						}

						case C_TypeSymb :
						{
							if ((Ret = hps_code_symb (element.data.Symb, &addr)) == HPS_OK)
							{
								Ret = hps_objsize_type (DOSYMB, (void *) &element.data.Symb, &size);
							}
							break;
						}

						if (Ret != HPS_OK)
						{
							break;
						}
					}

					addr += size;
					level++;
				}
				
				sat_poke (addr, SEMI, 5);
			}
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}

	return (Ret);
}
