#include <hpgcc49.h>
#include "hpspriv.h"
#include <hpstack.h>

int hps_pick_uint (int level, ULONGLONG *val)
{
	int Ret;

	if (val)
	{
		int depth;
		
		// Gets the stack depth
		(void) hps_depth (&depth);
		
		// Checks that the asked level exists
		if ((level > 0) && (level <= depth))
		{
			hpobj_t obj;
			int incr;
							
			// Gets the address of the object located at this level
			unsigned address = sat_peek (sat_peek (SAT_DSKTOP, 5) + (level-1) * 5, 5);
							
			// Tries to decode the object
			obj.type = 0;
			Ret = hps_decode_uint (address, &obj, &incr);
			*val = obj.data.dohxs;
		}
		else
		{
			Ret = HPS_ERROR_STACK;
		}
	}
	else
	{
		Ret = HPS_ERROR_PAR;
	}
		
	return (Ret);
}
