#include <hpgcc49.h>
#include <hpstack.h>

int main (void)
{
	int ret;

	// Picks a list at the second level of the stack
	list_t *lst;
	
	if ((ret = hps_pick_list (2, &lst)) == HPS_OK)
	{
		// Gets the 3d element
		hpobj_t *obj;
		
		if ((ret = hps_list_get (lst, 3, &obj)) == HPS_OK)
		{
			// Pushes it onto the stack
			ret = hps_push (obj);
			(void) hps_obj_destroy (&obj);
		}
		
		// Frees the allocated objects
		(void) hps_list_destroy (&lst);
	}
		
	if (ret != HPS_OK)
	{
		hps_push_str (hps_error (ret));
	}
	
	return (0);
}

