#include <hpgcc49.h>
#include <util.h>

int util_get_angle (void)
{
	// Gets angle setting within system flags : 5th nibble
	int f = sat_peek (C_AddrSysFlags + 4, 1);
	// Masks the value
	f &= C_AngModeMask;
	
	return (f);
}

void util_set_angle (int value)
{
	// Limits range
	value %= 3;
	// Gets angle setting within system flags : 5th nibble
	int f = sat_peek (C_AddrSysFlags + 4, 1);
	// Resets the current setting
	f &= ~C_AngModeMask;
	// Sets the mode
	f |= value;
	// Writes the new state
	sat_poke (C_AddrSysFlags + 4, f, 1);
}
